//
// THIS FILE IS COPYRIGHT 1994, 1995 BY TELENOR RESEARCH, NORWAY
//
//                        ALL RIGHTS RESERVED.
//
// For rights granted to the public see the COPYRIGHT file
//
//
// main.cc	The main routine for the FFW merge program.
//
// Author:  Ken Ronny Schouten

#include <stream.h>
#include <stdlib.h>
#include <Disk.h>
#include <lang.h>

int main(int argc, char **argv)
{
    // What about an -f option ?
    if (argc != 4) {
	cout.form(UsageMerge, argv[0]);
	exit(1);
    }

    Disk disk1((unsigned char *) argv[1], DWRITE);
    switch ((disk1.error())) {
    case 0:
	break;
    case DOPEN:
	cout.form(OpenFile, argv[1]);
	exit(1);
    default:
	cout.form(UnknownError, disk1.error(), "Disk::Disk()");
	exit(1);
    }

    Disk disk2((unsigned char *) argv[2], DREAD);
    switch ((disk2.error())) {
    case DOK:
	break;
    case DOPEN:
	cout.form(OpenFile, argv[2]);
	exit(1);
    case DBAD:
	cout.form(BadIndex, argv[2]);
	exit(1);
    default:
	cout.form(UnknownError, disk2.error(), "Disk::Disk()");
	exit(1);
    }

    Disk disk3((unsigned char *) argv[3], DREAD);
    switch ((disk3.error())) {
    case 0:
	break;
    case DOPEN:
	cout.form(OpenFile, argv[3]);
	exit(1);
    case DBAD:
	cout.form(BadIndex, argv[3]);
	exit(1);
    default:
	cout.form(UnknownError, disk3.error(), "Disk::Disk()");
	exit(1);
    }

    disk1.Merge(disk2, disk3);
    switch ((disk1.error())) {
    case DOK:
	break;
    default:
	cout.form(UnknownError, disk1.error(), "Disk::Disk()");
	exit(1);
    }

    exit(0);
}



