//
// THIS FILE IS COPYRIGHT 1994, 1995 BY TELENOR RESEARCH, NORWAY
//
//                        ALL RIGHTS RESERVED.
//
// For rights granted to the public see the COPYRIGHT file
//
//
// TermNode.cc	TermNode class for the syntax tree
//
// Author: Haiyan Yang

#include <iostream.h>
#include <Disk.h>
#include "TermNode.h"
#include "SetNode.h"


ostream& operator<<(ostream& os, TermNode& n)
{
    return n.print(os);
}


SetNode* OrTermNode::build()
{
    SetNode* a = _left->build();
    SetNode* b = _right->build();
    SetNode* c;

    if (a->isNot() && b->isNot()) {
	c = new NotSetNode(new CutSetNode(((NotSetNode*)a)->child(),
					  ((NotSetNode*)b)->child()));
	delete a;
	delete b;
	return c;
    }
    if (a->isNot() && !(b->isNot())) {
	c = new NotSetNode(new DiffSetNode(((NotSetNode*)a)->child(), b));
	delete a;
	return c;
    }
    if (!(a->isNot()) && b->isNot()) {
	c = new NotSetNode(new DiffSetNode(((NotSetNode*)b)->child(), a));
	delete b;
	return c;
    }

    // No node isNot
    return new UnionSetNode(a, b);
};


	
SetNode* AndTermNode::build()
{
    SetNode* a = _left->build();
    SetNode* b = _right->build();
    SetNode* c;

    if (a->isNot() && b->isNot()) {
	c = new NotSetNode(new UnionSetNode(((NotSetNode*)a)->child(),
					    ((NotSetNode*)b)->child()));
	delete a;
	delete b;
	return c;
    }
    if (a->isNot() && !(b->isNot())) {
	c = new DiffSetNode(b, ((NotSetNode*)a)->child());
	delete a;
	return c;
    }
    if (!(a->isNot()) && b->isNot()) {
	c = new DiffSetNode(a, ((NotSetNode*)b)->child());
	delete b;
	return c;
    }

    // No node isNot
    return new CutSetNode(a, b);
}


SetNode* NotTermNode::build()
{
    SetNode* n = _child->build();

    if (n->isNot()) {
	SetNode* tmp = ((NotSetNode*)n)->child();
	delete n;
	return tmp;
    } else {
	return new NotSetNode(_child->build());
    }
}


SetNode* TextTermNode::build()
{
    return new TextSetNode(_str);
}
